#include "rawproxy.h"
#include <direct.h>


void   main ( int argc, char *argv[] )
{
        USHORT          port;
        struct hostent *hostProxy;
        ULONG           myIPaddress;
        int             res;
        int             on = 1;

if ( argc < 4 )
    {
    printf ( "RawProxy version %s\n", VERSION_STRING );
    printf ( "Copyright (C) 2000 Andy A. Porro <porro@cbs-edu.chel.su>\n" );
    printf ( "Based on CHCProxy sources by (C) Vasim V. (http://members.tripod.com/~Vasim).\n\n" );
    printf ( "Usage : RawProxy local_port remote_server_address remote_port\n" );
    printf ( "     Used environment variables :\n"
             "     LANG - server's language (program obtains server's locale);\n"
             "     RAWPROXY_CLIENT_LOCALE - client's locale.\n"
             "     When running - exit Alt-X.\n" );
    exit ( 0 );
    }
port = (USHORT)atoi(argv[1]);   // local port number
proxyAddress = argv[2];         // remote server address
proxyPort = (USHORT)atoi(argv[3]);// remote server port number

setServerLocale ();             // set up server's locale
setClientLocale ();             // set up client's locale
initTranslation ();             // init translation (load tables etc.)

sock_init();                    // init sockets

if ( !strcmpi(proxyAddress, "localhost") )
    proxyIPaddress = (1 * 256 * 256 * 256) + 127;
else
    {
    if ( (proxyAddress[0] >= '0') && (proxyAddress[0] <= '9') )
        proxyIPaddress = inet_addr(proxyAddress);
    else
        {
        hostProxy = gethostbyname(proxyAddress);
        if ( hostProxy == NULL )
            {
            fprintf(stderr, "Proxy address %s is unknown\n", proxyAddress);
            exit(-1);
            }
        else
            proxyIPaddress = *((ULONG *)hostProxy->h_addr);
        }
    }
myIPaddress = INADDR_ANY;
mainSocket = socket ( AF_INET, SOCK_STREAM, 0 );
if ( mainSocket < 0 )
    {
    printSockError ( "Create main socket" );
    Quit(-1);
    }
setsockopt ( mainSocket, SOL_SOCKET, SO_REUSEADDR, (void *)&on, sizeof(on) );
setsockopt ( mainSocket, SOL_SOCKET, SO_KEEPALIVE, (void *)&on, sizeof(on) );
memset ( (void *)&serverSocket, 0, sizeof(serverSocket) );
serverSocket.sin_family = AF_INET;
serverSocket.sin_port = htons(port);
serverSocket.sin_addr.s_addr = myIPaddress;

if( bind(mainSocket,(struct sockaddr *)&serverSocket,sizeof(serverSocket)) < 0 )
    {
    printSockError ( "Bind main socket" );
    Quit(-1);
    }
if ( listen(mainSocket, inputQueue) != 0 )
    {
    printSockError ( "Listen main socket" );
    Quit(-1);
    }

linkSem = createEvent();        // start main server thread
threadsNumber = 2;
if ( DosCreateThread(&serverPID,serverThread,0,0L,THREAD_STACK_SIZE) )
    {
    fprintf ( stderr, "Startup : start server thread error.\n" );
    Quit ( -1 );
    }

Menu ();

pulseEvent ( linkSem );

Quit ( 0 );
}
