#define BSD_SELECT
#define VERSION_STRING  "V1.0 beta"

#define TCPV40HDRS
#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES
#include <os2.h>

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/select.h>
#include <process.h>


#define _MAX_INCOMING_QUEUE     128     // max queue size for listen
#define THREAD_STACK_SIZE       16384   // stack size for new threads
#define S_EINTR                 SOCEINTR
#define ERRNO                   sock_errno()
#define SBUF                    long
#define BUFFER_SIZE             3072    // buffer size for each input/output thread
#define	KEY_CANCEL	        0x2d00

/*
    receive status
*/
#define _FLAG_ERROR    -1       // error at receive 
#define _FLAG_NODATA   0        // no bytes receive (for future extension)
#define _FLAG_MOREDATA 1        // need more receive 
#define _FLAG_NEEDSEND 2        // need send (scount bytes from psend) 

#define _FROM_PROXY    1
#define _TO_PROXY      2

/* 
    Data types 
*/
typedef struct Sockets {
        int    proxySocket;
        int    inpSocket;
        ULONG  flagExit;
        ULONG  hev;
        UCHAR  inpBuf [BUFFER_SIZE];
        int    inpSize;            // number of bytes in buffer
        UCHAR  outBuf [BUFFER_SIZE];
        int    outSize;            // number of bytes in buffer
        }  Sockets;

typedef struct Request {
        int    socket;
        ULONG volatile TID;
        int    threadNumber;
        struct sockaddr_in client;
        }  Request;

#define printSockError(s)      fprintf(stderr,"Sock error %d : %s\n", ERRNO,s)

extern ULONG  proxyIPaddress;
extern UCHAR  *proxyAddress;
extern USHORT proxyPort;
extern int    mainSocket;
extern int volatile threadsNumber;
extern ULONG  linkSem;
extern ULONG  serverPID;
extern int    inputQueue;
extern struct sockaddr_in serverSocket;
extern UCHAR  serverLocale [32];
extern UCHAR  clientLocale [32];

void _System newRequest ( ULONG num_socket );
void _System toProxyThread ( ULONG idsocks );
void _System serverThread ( ULONG isock );
int   sendBuffer ( Sockets *socks, USHORT dir );
int   receiveBuffer ( Sockets *socks, USHORT dir );
void  Quit ( int res );
HEV   createEvent ( void );
void  closeEvent ( HEV sem );
void  resetEvent ( HEV sem );
void  pulseEvent ( HEV sem );
void  waitEvent  ( HEV sem );
BOOL  checkEvent ( HEV sem );
int   newConnection ( Request *preq );
void  closeConnection ( int insock );
void  Menu ( void );
void  setServerLocale ( void );
void  setClientLocale ( void );
void  initTranslation ( void );
UCHAR *toClient ( UCHAR text[], int len );
UCHAR *toServer ( UCHAR text[], int len );
